package com.ashokit.ticketbooking.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.ashokit.ticketbooking.model.Ticket;
import com.ashokit.ticketbooking.service.TicketService;

@RestController
@RequestMapping(value="/tickets")
//http://localhost:8080/tickets==> TicketController obj=ioc.getTicketController();
public class TicketController {
	
	
	/*
	 * 
	 * 
	 * @RestController ==> Exposing Ticket  Booking Functionality to outside world
	 * 
	 * Through REST Services ==> JAX RS ==> Java API for RestServices
	 * 
	 * REST Services ==> To achieve hetero genious communication we can use rest services
	 *               ==> Common Language ==> JSON ==> Java Script Object Notation
	 *               
	 *  VERBS ==> @GET ==>Retieve the Data + @RequestMapping ==>@GetMapping
	 *  
	 *  	  ==> @POST ==> Creates the Data + @RequestMapping ==> @PostMapping
	 *  
	 *         ==> @PUT ==> Updates the Data + @RequestMapping ==> @PutMapping
	 *         
	 *         ==> @DELETE ==> Delete the Data + @RequestMapping ==> @DeleteMapping
	 * 
	 * 
	 *  Spring Boot automatically takes care of Marshalling and UnMarshalling with JackSon Library
	 *  
	 *  Marshalling ==> Java to JSON Conversion
	 *  
	 *  UnMarshalling ==> JSON TO Java Conversion
	 */

	
	@Autowired
	private TicketService ticketService;
	
	
	@GetMapping(value="/all")
	//http://localhost:8080/tickets/all==> obj.getAllTickets()
	public Iterable<Ticket> getAllTickets(){
		return ticketService.getAllTickets();
	}
	
}
